package it.enea.xlab.GECORegistration.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import it.enea.scp.idp.sdk.business.IdpManager;
import it.enea.xlab.GECORegistration.service.identityManager.IdpClient;


@Configuration
public class IdpClientConfig {
	@Value("${idp.auth-server-url}")
	private String serverUrl;

	@Value("${idp.clientId}")
	private String clientId;

	@Value("${idp.clientSecret}")
	private String clientSecret;

	@Value("${idp.m2mUserEmail}")
	private String m2mUserEmail;

	@Value("${idp.m2mUserPwd}")
	private String m2mUserPwd;
	
	@Bean
	public IdpClient idpClient() {
        
		IdpClient idp = new IdpClient();
		IdpManager idpm = new IdpManager(
				serverUrl, 
				clientId, 
				clientSecret);
		
		idpm.setCredentials ( m2mUserEmail, m2mUserPwd);
		idp.setIdpClientLocal(idpm);
		return idp;
	}
	
	
}