package it.enea.xlab.GECORegistration.config;

import org.keycloak.OAuth2Constants;
import org.keycloak.admin.client.Keycloak;
import org.keycloak.admin.client.KeycloakBuilder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import it.enea.xlab.GECORegistration.service.identityManager.KeycloakClient;

@Configuration
public class KeycloakClientConfig {

	@Value("${keycloak.auth-server-url}")
	private String serverUrl;
	
	@Value("${keycloak.realm}")
	private String realm;
	
	@Value("${keycloak.resource}")
	private String clientId;
	
	@Value("${keycloak.credentials.secret}")
	private String clientSecret;
	
	@Value("${k.adminusername}")
	private String adminUsername;
	
	@Value("${k.adminpassword}")
	private String adminPassword;
	
	@Bean
	public KeycloakClient keycloakClient() {
        
		KeycloakClient kcl = new KeycloakClient();
		
        Keycloak keycloak = KeycloakBuilder.builder() //
				.serverUrl(serverUrl) //
				.realm(realm) //
				.grantType(OAuth2Constants.PASSWORD) //
				.clientId(clientId) //
				.clientSecret(clientSecret) //
				.username(adminUsername) //  "gianluca" 
				.password(adminPassword) // "lupacchiotto603!"
				.build();
        
        kcl.setKeycloakClientLocal(keycloak);
        
		return kcl;
	}

//	@Bean("kClientWithUsernameAndPassword")
//	public KeycloakClient keycloakClient(String username, String password) {
//        
//		KeycloakClient kcl = new KeycloakClient();
//		
//        Keycloak keycloak = KeycloakBuilder.builder() //
//				.serverUrl(serverUrl) //
//				.realm(realm) //
//				.grantType(OAuth2Constants.PASSWORD) //
//				.clientId(clientId) //
//				.clientSecret(clientSecret) //
//				.username(username) //  "gianluca" 
//				.password(password) // "lupacchiotto603!"
//				.build();
//        
//        kcl.setKeycloakClientLocal(keycloak);
//        
//		return kcl;
//	}
	
}
