package it.enea.xlab.GECORegistration.service.data;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import it.enea.scp.idp.sdk.model.UserDto;
import it.enea.xlab.GECORegistration.data.InputParameters;
import it.enea.xlab.GECORegistration.model.parametricQuery.ParametricQuery;
import it.enea.xlab.GECORegistration.model.user.User;
import it.enea.xlab.GECORegistration.service.identityManager.IIdpClientManager;
import it.enea.xlab.GECORegistration.service.parametricQuery.LocalQueryParameterInterface;
import it.enea.xlab.GECORegistration.service.parametricQuery.ParametricQueryInterface;
import it.enea.xlab.GECORegistration.service.parametricQuery.ParametricQueryManager;
import it.enea.xlab.GECORegistration.service.parametricQuery.ParametricQueryManager.ResultWithMetadata;
import it.enea.xlab.GECORegistration.service.user.NewUserInterface;
import lombok.extern.log4j.Log4j2;


@Service
@Log4j2
public class DataService implements IDataService {
	@Autowired
	LocalQueryParameterInterface lqpInterface;
	
	@Autowired
	NewUserInterface userInterface;

	
	@Autowired
	ParametricQueryInterface pqueryInterface;
	
	
	@Autowired
	ParametricQueryManager pqm;

	@Autowired
	IIdpClientManager idpClientManager;

	@Override
	public ResultWithMetadata getData(
			 Map<String, String> inputData,
			 String token,
			 String language)
	 {
		
		log.info("Input data:" + inputData.toString());
		if (idpClientManager.isValid(token)) {
			
			UserDto userdto = idpClientManager.getUserFromToken(token);
			
			User user = userInterface.findBySubject(userdto.getUuid());
			
			inputData.put("userid", user.getUserid().toString());
			
			//inputData.setUserid(user.getUserid().intValue());
			
					
		}else {
			log.info("Warning: token is not valid");
		}	
		
		
		
		ParametricQuery pq = pqueryInterface.findByQueryid(new Long(inputData.get("queryid")));
		ResultWithMetadata data = pqm.executeQuery(pq, inputData, language);

		return data;	
		
	}

}

